Index: src/dock_gui.cpp
===================================================================
--- src/dock_gui.cpp	(revision 13683)
+++ src/dock_gui.cpp	(working copy)
@@ -46,7 +46,15 @@
 
 static void PlaceDocks_Dock(TileIndex tile)
 {
-	DoCommandP(tile, _ctrl_pressed, 0, CcBuildDocks, CMD_BUILD_DOCK | CMD_MSG(STR_9802_CAN_T_BUILD_DOCK_HERE));
+	uint32 p2 = (INVALID_STATION << 16); // no station to join
+
+	/* tile is always the land tile, so need to evaluate _thd.pos */
+	if (StationJoinerNeeded(TileXY(_thd.pos.x / TILE_SIZE, _thd.pos.y / TILE_SIZE), _thd.size.x / TILE_SIZE, _thd.size.y / TILE_SIZE)) {
+		CommandContainer cmd = {tile, _ctrl_pressed, p2, CcBuildDocks, CMD_BUILD_DOCK | CMD_MSG(STR_9802_CAN_T_BUILD_DOCK_HERE)};
+		ShowSelectStation(cmd, STATION_DOCK, true, true);
+	} else {
+		DoCommandP(tile, _ctrl_pressed, p2, CcBuildDocks, CMD_BUILD_DOCK | CMD_MSG(STR_9802_CAN_T_BUILD_DOCK_HERE));
+	}
 }
 
 static void PlaceDocks_Depot(TileIndex tile)
@@ -87,7 +95,7 @@
 	DTW_CAPTION,                   ///< Window caption
 	DTW_STICKY,                    ///< Sticky window button
 	DTW_BUTTONS_BEGIN,             ///< Begin of clickable buttons (except seperating panel)
-	DTW_CANAL = DTW_BUTTONS_BEGIN, ///< Build canal button
+	DTW_CANAL = DTW_BUTTONS_BEGIN, ///< Build canal button	
 	DTW_LOCK,                      ///< Build lock button
 	DTW_SEPERATOR,                 ///< Seperating panel between lock and demolish
 	DTW_DEMOLISH,                  ///< Demolish aka dynamite button
@@ -136,7 +144,6 @@
 
 static void BuildDocksClick_River(Window *w)
 {
-	if (_game_mode != GM_EDITOR) return;
 	HandlePlacePushButton(w, DTW_RIVER, SPR_CURSOR_RIVER, VHM_RECT, PlaceDocks_BuildRiver);
 }
 
@@ -227,7 +234,6 @@
 				case DDSP_CREATE_RIVER:
 					DoCommandP(end_tile, start_tile, 2, CcBuildCanal, CMD_BUILD_CANAL | CMD_MSG(STR_CANT_PLACE_RIVERS));
 					break;
-
 				default: break;
 			}
 		}
@@ -239,6 +245,7 @@
 
 		delete FindWindowById(WC_BUILD_STATION, 0);
 		delete FindWindowById(WC_BUILD_DEPOT, 0);
+		delete FindWindowById(WC_SELECT_STATION, 0);
 	}
 
 	virtual void OnPlacePresize(Point pt, TileIndex tile_from)
@@ -252,8 +259,8 @@
 
 static const Widget _build_docks_toolb_widgets[] = {
 {   WWT_CLOSEBOX,   RESIZE_NONE,     7,     0,    10,     0,    13, STR_00C5,                        STR_018B_CLOSE_WINDOW},                  // DTW_CLOSEBOX
-{    WWT_CAPTION,   RESIZE_NONE,     7,    11,   147,     0,    13, STR_9801_WATERWAYS_CONSTRUCTION, STR_018C_WINDOW_TITLE_DRAG_THIS},        // DTW_CAPTION
-{  WWT_STICKYBOX,   RESIZE_NONE,     7,   148,   159,     0,    13, 0x0,                             STR_STICKY_BUTTON},                      // DTW_STICKY
+{    WWT_CAPTION,   RESIZE_NONE,     7,    11,   168,     0,    13, STR_9801_WATERWAYS_CONSTRUCTION, STR_018C_WINDOW_TITLE_DRAG_THIS},        // DTW_CAPTION
+{  WWT_STICKYBOX,   RESIZE_NONE,     7,   169,   180,     0,    13, 0x0,                             STR_STICKY_BUTTON},                      // DTW_STICKY
 {     WWT_IMGBTN,   RESIZE_NONE,     7,     0,    21,    14,    35, SPR_IMG_BUILD_CANAL,             STR_BUILD_CANALS_TIP},                   // DTW_CANAL
 {     WWT_IMGBTN,   RESIZE_NONE,     7,    22,    43,    14,    35, SPR_IMG_BUILD_LOCK,              STR_BUILD_LOCKS_TIP},                    // DTW_LOCK
 
@@ -263,13 +270,13 @@
 {     WWT_IMGBTN,   RESIZE_NONE,     7,    71,    92,    14,    35, SPR_IMG_SHIP_DEPOT,              STR_981E_BUILD_SHIP_DEPOT_FOR_BUILDING}, // DTW_DEPOT
 {     WWT_IMGBTN,   RESIZE_NONE,     7,    93,   114,    14,    35, SPR_IMG_SHIP_DOCK,               STR_981D_BUILD_SHIP_DOCK},               // DTW_STATION
 {     WWT_IMGBTN,   RESIZE_NONE,     7,   115,   136,    14,    35, SPR_IMG_BOUY,                    STR_9834_POSITION_BUOY_WHICH_CAN},       // DTW_BUOY
-{     WWT_EMPTY,    RESIZE_NONE,     0,     0,     0,     0,     0, 0x0,                             STR_NULL},                               // DTW_RIVER
-{     WWT_IMGBTN,   RESIZE_NONE,     7,   137,   159,    14,    35, SPR_IMG_AQUEDUCT,                STR_BUILD_AQUEDUCT},                     // DTW_BUILD_AQUEDUCT
+{     WWT_IMGBTN,   RESIZE_NONE,     7,   137,   158,    14,    35, SPR_IMG_BUILD_RIVER,             STR_CREATE_RIVER},                       // DTW_RIVER
+{     WWT_IMGBTN,   RESIZE_NONE,     7,   159,   180,    14,    35, SPR_IMG_AQUEDUCT,                STR_BUILD_AQUEDUCT},                     // DTW_BUILD_AQUEDUCT
 {   WIDGETS_END},
 };
 
 static const WindowDesc _build_docks_toolbar_desc = {
-	WDP_ALIGN_TBR, 22, 160, 36, 160, 36,
+	WDP_ALIGN_TBR, 22, 181, 36, 181, 36,
 	WC_BUILD_TOOLBAR, WC_NONE,
 	WDF_STD_TOOLTIPS | WDF_STD_BTN | WDF_DEF_WIDGET | WDF_STICKY_BUTTON,
 	_build_docks_toolb_widgets,
Index: src/road_gui.cpp
===================================================================
--- src/road_gui.cpp	(revision 13683)
+++ src/road_gui.cpp	(working copy)
@@ -205,12 +205,18 @@
 static void PlaceRoadStop(TileIndex tile, uint32 p2, uint32 cmd)
 {
 	uint32 p1 = _road_station_picker_orientation;
+	SB(p2, 16, 16, INVALID_STATION); // no station to join
 
 	if (p1 >= DIAGDIR_END) {
 		SetBit(p2, 1); // It's a drive-through stop
 		p1 -= DIAGDIR_END; // Adjust picker result to actual direction
 	}
-	DoCommandP(tile, p1, p2, CcRoadDepot, cmd);
+	if (StationJoinerNeeded(tile, 1, 1)) {
+		CommandContainer cmdcont = {tile, p1, p2, CcRoadDepot, cmd};
+		ShowSelectStation(cmdcont, STATION_BUS, true, true);
+	} else {
+		DoCommandP(tile, p1, p2, CcRoadDepot, cmd);
+	}
 }
 
 static void PlaceRoad_BusStation(TileIndex tile)
@@ -527,6 +533,7 @@
 		delete FindWindowById(WC_BUS_STATION, 0);
 		delete FindWindowById(WC_TRUCK_STATION, 0);
 		delete FindWindowById(WC_BUILD_DEPOT, 0);
+		delete FindWindowById(WC_SELECT_STATION, 0);
 	}
 
 	virtual void OnPlaceDrag(ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
Index: src/saveload.h
===================================================================
--- src/saveload.h	(revision 13683)
+++ src/saveload.h	(working copy)
@@ -13,6 +13,9 @@
 
 #define SIZE_MAX ((size_t)-1)
 
+#define SL_VERSION_PATCH	123
+#define SL_VERSION_TRUNK     99
+
 enum SaveOrLoadResult {
 	SL_OK     = 0, ///< completed successfully
 	SL_ERROR  = 1, ///< error that was caught before internal structures were modified
Index: src/roadveh_cmd.cpp
===================================================================
--- src/roadveh_cmd.cpp	(revision 13683)
+++ src/roadveh_cmd.cpp	(working copy)
@@ -43,6 +43,7 @@
 #include "depot_base.h"
 #include "depot_func.h"
 #include "effectvehicle_func.h"
+#include "sharedinfrastructure.h"
 
 #include "table/strings.h"
 
@@ -187,7 +188,7 @@
 	/* The ai_new queries the vehicle cost before building the route,
 	 * so we must check against cheaters no sooner than now. --pasky */
 	if (!IsRoadDepotTile(tile)) return CMD_ERROR;
-	if (!IsTileOwner(tile, _current_player)) return CMD_ERROR;
+	if (!IsTileOwner(tile, _current_player) && !SharedRoadDepots(tile, _current_player)) return CMD_ERROR;
 
 	if (HasTileRoadType(tile, ROADTYPE_TRAM) != HasBit(EngInfo(p1)->misc_flags, EF_ROAD_TRAM)) return_cmd_error(STR_DEPOT_WRONG_DEPOT_TYPE);
 
@@ -288,6 +289,7 @@
 		GetPlayer(_current_player)->num_engines[p1]++;
 	}
 
+	SharedDepotProvision(cost, GetTileOwner(tile), flags);
 	return cost;
 }
 
@@ -823,6 +825,7 @@
 
 static void RoadVehArrivesAt(const Vehicle* v, Station* st)
 {
+	if (st->owner != v->owner) SharedStationFee(st->owner, v->index);
 	if (IsCargoInClass(v->cargo_type, CC_PASSENGERS)) {
 		/* Check if station was ever visited before */
 		if (!(st->had_vehicle_of_type & HVOT_BUS)) {
@@ -834,7 +837,7 @@
 				v->index,
 				0);
 		}
-	} else {
+	} else {		
 		/* Check if station was ever visited before */
 		if (!(st->had_vehicle_of_type & HVOT_TRUCK)) {
 			st->had_vehicle_of_type |= HVOT_TRUCK;
@@ -1066,14 +1069,14 @@
 	TrackdirBits trackdirs = TrackStatusToTrackdirBits(ts);
 
 	if (IsTileType(tile, MP_ROAD)) {
-		if (IsRoadDepot(tile) && (!IsTileOwner(tile, v->owner) || GetRoadDepotDirection(tile) == enterdir || (GetRoadTypes(tile) & v->u.road.compatible_roadtypes) == 0)) {
+		if (IsRoadDepot(tile) && ((!IsTileOwner(tile, v->owner) && !SharedRoadDepots(tile,v->owner)) || GetRoadDepotDirection(tile) == enterdir || (GetRoadTypes(tile) & v->u.road.compatible_roadtypes) == 0)) {
 			/* Road depot owned by another player or with the wrong orientation */
 			trackdirs = TRACKDIR_BIT_NONE;
 		}
 	} else if (IsTileType(tile, MP_STATION) && IsStandardRoadStopTile(tile)) {
 		/* Standard road stop (drive-through stops are treated as normal road) */
 
-		if (!IsTileOwner(tile, v->owner) || GetRoadStopDir(tile) == enterdir || RoadVehHasArticPart(v)) {
+		if (((!IsTileOwner(tile, v->owner))&& !SharedRoadStops(tile,v->owner)) || GetRoadStopDir(tile) == enterdir || RoadVehHasArticPart(v)) {
 			/* different station owner or wrong orientation or the vehicle has articulated parts */
 			trackdirs = TRACKDIR_BIT_NONE;
 		} else {
Index: src/economy_type.h
===================================================================
--- src/economy_type.h	(revision 13683)
+++ src/economy_type.h	(working copy)
@@ -118,10 +118,12 @@
 	EXPENSES_AIRCRAFT_RUN,
 	EXPENSES_SHIP_RUN,
 	EXPENSES_PROPERTY,
+	EXPENSES_SHARED_INF_RUN,
 	EXPENSES_TRAIN_INC,
 	EXPENSES_ROADVEH_INC,
 	EXPENSES_AIRCRAFT_INC,
 	EXPENSES_SHIP_INC,
+	EXPENSES_SHARED_INF_INC,
 	EXPENSES_LOAN_INT,
 	EXPENSES_OTHER,
 	EXPENSES_END,
Index: src/bridge.h
===================================================================
--- src/bridge.h	(revision 13683)
+++ src/bridge.h	(working copy)
@@ -47,6 +47,8 @@
 bool CheckBridge_Stuff(BridgeType bridge_type, uint bridge_len, uint32 flags = 0);
 int CalcBridgeLenCostFactor(int x);
 
+BridgeType GetFastestAvailableBridgeType(uint bridge_len);
+
 void ResetBridges();
 
 #endif /* BRIDGE_H */
Index: src/sharedinfrastructure.h
===================================================================
--- src/sharedinfrastructure.h	(revision 0)
+++ src/sharedinfrastructure.h	(revision 0)
@@ -0,0 +1,71 @@
+/* $Id: sharedinfrastructure.h $ */
+
+/** @file sharedinfrastructure.h Various declarations for shared infrastructures */
+
+#ifndef SHAREDINFRASTRUCTURE_H
+#define SHAREDINFRASTRUCTURE_H
+
+#include "openttd.h"
+#include "tile_type.h"
+#include "vehicle_type.h"
+
+/* bitmask of shared infrastructure */
+enum {
+	SHARED_NONE             =  0,             ///< No sharing
+	SHARED_RAILWAY_TRACKS   = (1 << 0),       ///< Railway tracks sharing 
+	SHARED_RAILWAY_STATIONS = (1 << 1),       ///< Railway station sharing
+	SHARED_RAILWAY_DEPOTS   = (1 << 2),       ///< Railway depots sharing
+	SHARED_AIRPORTS         = (1 << 3),       ///< Airports sharing
+	SHARED_ROAD_DEPOTS      = (1 << 4),       ///< Road depots sharing
+	SHARED_ROAD_STOPS       = (1 << 5),       ///< Road stops sharing
+	SHARED_WATER_DEPOTS     = (1 << 6),       ///< Water depots sharing
+	SHARED_HARBOURS         = (1 << 7),       ///< Road depots sharing
+	SHARED_ALL              = SHARED_RAILWAY_TRACKS | SHARED_RAILWAY_STATIONS | SHARED_RAILWAY_DEPOTS | SHARED_AIRPORTS
+					| SHARED_ROAD_DEPOTS | SHARED_ROAD_STOPS | SHARED_WATER_DEPOTS | SHARED_HARBOURS, ///< All sharing
+};
+
+/* variables for player's shared infrastructure GUI */
+extern bool _si_railway_tracks;               ///< allow railway tracks sharing
+extern bool _si_railway_stations;             ///< allow railway stations sharing
+extern bool _si_railway_depots;               ///< allow railway depots sharing
+extern bool _si_airports;                     ///< allow airports sharing
+extern bool _si_road_depots;                  ///< allow road depots sharing
+extern bool _si_road_stops;                   ///< allow road stops sharing
+extern bool _si_water_depots;                 ///< allow water depots sharing
+extern bool _si_harbours;                     ///< allow harbours sharing
+extern uint16 _si_tontile_cost;               ///< cost for tracks sharing payment (per 1000 tons per tiles)
+extern uint16 _si_landing_fee;                ///< cost for airports landing fee (per tons of cargo capacity)
+extern uint8 _si_provision;                   ///< value for depots provision (buy cost %)
+extern uint8 _si_road_stops_fee;              ///< cost for entering road stops (per tons of cargo capacity)
+extern uint8 _si_harbours_fee;                ///< cost for entering harbours (per tons of cargo capacity)
+
+/* shared infrastructure functions */
+bool SharedTracks(TileIndex tile, Owner owner);                               ///< check if tracks on tile are shared
+bool SharedRailwayStations(TileIndex tile, Owner owner);                      ///< check if railway station is shared
+bool SharedRailwayDepots(TileIndex tile, Owner owner);                        ///< check if railway depot is shared
+bool SharedRoadDepots(TileIndex tile, Owner owner);                           ///< check if road depot is shared
+bool SharedRoadStops(TileIndex tile, Owner owner);                            ///< check if road stops is shared
+bool SharedWaterDepots(TileIndex tile, Owner owner);                          ///< check if water depot is shared
+bool SharedHarbours(TileIndex tile, Owner owner);                             ///< check if harbour is shared
+bool SharedAirports(TileIndex tile, Owner owner);                             ///< check if airport is shared
+bool SharedDepotTransport(TileIndex tile, Owner owner, TransportType type);   ///< check if depot for this transport type is shared
+bool SharedDepotVehicleType(TileIndex tile, Owner owner, VehicleType type);   ///< check if depot for this vehicle type is shared
+bool SharedStation(TileIndex tile, Owner owner, VehicleType type);            ///< check if station is shared
+void SharedDepotProvision(CommandCost cost, Owner owner, uint32 flags);       ///< calculate depot provision
+void SharedStationFee(Owner station_owner, VehicleID vehicle);                ///< calculate station fee for this vehicle
+int32 SettingsEnableSharedRailwayStations(int32 p1);                          ///< activate railway tracks sharing when activating railway station sharing
+int32 SettingsEnableSharedRailwayTracks(int32 p1);                            ///< desactivate railway stations and depots sharing when removing tracks sharing
+void UpdateSharedOnRemove(VehicleID vehicle);                                 ///< clean infrastructure when removing vehicle
+void OnSharedClose(PlayerID old_player, uint closing_bit);                    ///< take care of vehicles on closing shared infrastructure
+void SharedCloseOnRoad (PlayerID p, VehicleID v);                             ///< remove road vehicles on closing shared infrastructure
+void SharedCloseOnRail (PlayerID p, VehicleID v);                             ///< remove rail vehicles on closing shared infrastructure
+void SharedCloseOnAir (PlayerID p, VehicleID v);                              ///< remove aircraft on closing shared airports 
+bool SharedCloseDepotTeleport (VehicleID v, uint16 depot);                    ///< teleport vehicle to depot, return false if failed
+bool SharedCloseHangarTeleport (VehicleID v, uint16 depot);                   ///< teleport vehicle to hangar, return false if failed
+uint16 SharedCloseGetFirstDepot (PlayerID p, VehicleID v, bool check_player); ///< get fist available depot to move vehicle on bankrupt company's shared infrastructure
+uint16 SharedCloseGetFirstHangar(PlayerID p, VehicleID v, bool check_player); ///< get fist available hangar to move aircraft on bankrupt company's shared airports
+
+CommandCost CmdSetSharedBoolValues(TileIndex tile, uint32 flags, uint32 p1, uint32 p2);  ///< set shared settings for player
+CommandCost CmdSetSharedIntValues(TileIndex tile, uint32 flags, uint32 p1, uint32 p2);   ///< set int shared settings for player
+
+#endif //SHAREDINFRASTRCUTURE_H
Index: src/signal.cpp
===================================================================
--- src/signal.cpp	(revision 13683)
+++ src/signal.cpp	(working copy)
@@ -18,6 +18,7 @@
 #include "track_func.h"
 #include "signal_func.h"
 #include "player_func.h"
+#include "sharedinfrastructure.h"
 
 
 /** these are the maximums used for updating signal blocks */
@@ -280,7 +281,7 @@
 
 		switch (GetTileType(tile)) {
 			case MP_RAILWAY: {
-				if (GetTileOwner(tile) != owner) continue; // do not propagate signals on others' tiles (remove for tracksharing)
+				if ((GetTileOwner(tile) != owner) && !SharedTracks(GetTileOwner(tile), owner)) continue; // do not propagate signals on tiles of those with whom you are not sharing track
 
 				if (IsRailDepot(tile)) {
 					if (enterdir == INVALID_DIAGDIR) { // from 'inside' - train just entered or left the depot
@@ -354,7 +355,7 @@
 
 			case MP_STATION:
 				if (!IsRailwayStation(tile)) continue;
-				if (GetTileOwner(tile) != owner) continue;
+				if ((GetTileOwner(tile) != owner) && !SharedTracks(GetTileOwner(tile), owner)) continue;
 				if (DiagDirToAxis(enterdir) != GetRailStationAxis(tile)) continue; // different axis
 				if (IsStationTileBlocked(tile)) continue; // 'eye-candy' station tile
 
@@ -364,7 +365,7 @@
 
 			case MP_ROAD:
 				if (!IsLevelCrossing(tile)) continue;
-				if (GetTileOwner(tile) != owner) continue;
+				if ((GetTileOwner(tile) != owner) && (!SharedTracks(GetTileOwner(tile), owner))) continue;
 				if (DiagDirToAxis(enterdir) == GetCrossingRoadAxis(tile)) continue; // different axis
 
 				if (!(flags & SF_TRAIN) && VehicleFromPos(tile, NULL, &TrainOnTileEnum)) flags |= SF_TRAIN;
@@ -372,7 +373,7 @@
 				break;
 
 			case MP_TUNNELBRIDGE: {
-				if (GetTileOwner(tile) != owner) continue;
+				if ((GetTileOwner(tile) != owner) && (!SharedTracks(GetTileOwner(tile), owner))) continue;
 				if (GetTunnelBridgeTransportType(tile) != TRANSPORT_RAIL) continue;
 				DiagDirection dir = GetTunnelBridgeDirection(tile);
 
Index: src/vehicle.cpp
===================================================================
--- src/vehicle.cpp	(revision 13683)
+++ src/vehicle.cpp	(working copy)
@@ -1967,6 +1967,7 @@
 	SLE_CONDNULL(5,                                                         0, 57),
 	    SLE_VAR(Vehicle, engine_type,          SLE_UINT16),
 
+	    SLE_CONDARR(Vehicle, shared_tontiles,  SLE_UINT64, MAX_PLAYERS,     SL_VERSION_PATCH, SL_MAX_VERSION),
 	    SLE_VAR(Vehicle, max_speed,            SLE_UINT16),
 	    SLE_VAR(Vehicle, cur_speed,            SLE_UINT16),
 	    SLE_VAR(Vehicle, subspeed,             SLE_UINT8),
@@ -2255,7 +2256,7 @@
 			cp->source_xy       = _cargo_source_xy;
 			cp->count           = _cargo_count;
 			cp->days_in_transit = _cargo_days;
-			cp->feeder_share    = _cargo_feeder_share;
+			cp->feeder_share[0] = _cargo_feeder_share;
 			cp->loaded_at_xy    = _cargo_loaded_at_xy;
 			v->cargo.Append(cp);
 		}
Index: src/viewport.cpp
===================================================================
--- src/viewport.cpp	(revision 13683)
+++ src/viewport.cpp	(working copy)
@@ -2190,12 +2190,17 @@
 		/* clear the old selection? */
 		if (_thd.drawstyle) SetSelectionTilesDirty();
 
-		_thd.drawstyle = _thd.new_drawstyle;
-		_thd.pos = _thd.new_pos;
-		_thd.size = _thd.new_size;
-		_thd.outersize = _thd.new_outersize;
-		_thd.dirty = 0xff;
+		if (!_thd.lockPos) {
+			_thd.pos = _thd.new_pos;
+			_thd.drawstyle = _thd.new_drawstyle;
+		}
 
+		if (!_thd.lockSize) {
+			_thd.size = _thd.new_size;
+			_thd.outersize = _thd.new_outersize;
+			_thd.dirty = 0xff;
+		}
+
 		/* draw the new selection? */
 		if (_thd.new_drawstyle) SetSelectionTilesDirty();
 	}
@@ -2717,6 +2722,10 @@
 
 void SetObjectToPlace(CursorID icon, SpriteID pal, ViewportHighlightMode mode, WindowClass window_class, WindowNumber window_num)
 {
+	/* unlock position and size */
+	_thd.lockPos = false;
+	_thd.lockSize = false;
+
 	/* undo clicking on button and drag & drop */
 	if (_thd.place_mode != VHM_NONE || _special_mouse_mode == WSM_DRAGDROP) {
 		Window *w = FindWindowById(_thd.window_class, _thd.window_number);
Index: src/genworld.cpp
===================================================================
--- src/genworld.cpp	(revision 13683)
+++ src/genworld.cpp	(working copy)
@@ -35,7 +35,6 @@
 bool GenerateTowns();
 void GenerateTrees();
 
-void StartupEconomy();
 void StartupPlayers();
 void StartupDisasters();
 
Index: src/newgrf_station.h
===================================================================
--- src/newgrf_station.h	(revision 13683)
+++ src/newgrf_station.h	(working copy)
@@ -110,6 +110,7 @@
 StationClassID AllocateStationClass(uint32 cls);
 void SetStationClassName(StationClassID sclass, StringID name);
 StringID GetStationClassName(StationClassID sclass);
+const StationSpec* GetStationSpec(TileIndex t);
 
 uint GetNumStationClasses();
 uint GetNumCustomStations(StationClassID sclass);
Index: src/vehicle_base.h
===================================================================
--- src/vehicle_base.h	(revision 13683)
+++ src/vehicle_base.h	(working copy)
@@ -193,6 +193,7 @@
 extern void AfterLoadVehicles(bool clear_te_id);
 struct LoadgameState;
 extern bool LoadOldVehicle(LoadgameState *ls, int num);
+// extern bool SharedCloseHangarTeleport (VehicleID vehicle, StationID station);
 
 struct Vehicle : PoolItem<Vehicle, VehicleID, &_Vehicle_pool>, BaseVehicle {
 private:
@@ -203,6 +204,7 @@
 	friend const SaveLoad *GetVehicleDescription(VehicleType vt); ///< So we can use private/protected variables in the saveload code
 	friend void AfterLoadVehicles(bool clear_te_id);              ///< So we can set the previous and first pointers while loading
 	friend bool LoadOldVehicle(LoadgameState *ls, int num);       ///< So we can set the proper next pointer while loading
+	friend bool SharedCloseHangarTeleport (VehicleID vehicle, StationID station); ///< So we can set the proper next pointer while teleporting an air vehicle
 
 	Vehicle *depot_list;     ///< NOSAVE: linked list to tell what vehicles entered a depot during the last tick. Used by autoreplace
 
@@ -264,6 +266,8 @@
 	int8 y_offs;             // y offset for vehicle sprite
 	EngineID engine_type;
 
+	OverflowSafeInt64 shared_tontiles[MAX_PLAYERS];  //Amount of tons*tiles traveled on shared tracks
+
 	TextEffectID fill_percent_te_id; // a text-effect id to a loading indicator object
 	UnitID unitnumber;       // unit number, for display purposes only
 
Index: src/tilehighlight_type.h
===================================================================
--- src/tilehighlight_type.h	(revision 13683)
+++ src/tilehighlight_type.h	(working copy)
@@ -70,6 +70,9 @@
 
 	ViewportPlaceMethod select_method;
 	ViewportDragDropSelectionProcess select_proc;
+	
+	bool lockPos;  //if position changes are taken, or not
+	bool lockSize; //if size changes are taken, or not
 
 	TileIndex redsq;
 };
